Index: code/branches/questsystem/src/orxonox/objects/AddQuestHint.cc
===================================================================
--- code/branches/questsystem/src/orxonox/objects/AddQuestHint.cc	(revision 2076)
+++ code/branches/questsystem/src/orxonox/objects/AddQuestHint.cc	(revision 2081)
@@ -31,4 +31,5 @@
 
 #include "QuestManager.h"
+#include "QuestItem.h"
 #include "AddQuestHint.h"
 
@@ -56,4 +57,14 @@
         XMLPortParam(AddQuestHint, "hintId", setHintId, getHintId, xmlelement, mode);
         
+    }
+
+    inline void AddQuestHint::setHintId(const std::string & id)
+    {
+        if(!QuestItem::isId(id))
+        {
+            COUT(2) << "Invalid id. QuestItem id {" << id << "} could not be set." << std::endl;
+            return;
+        }
+        this->hintId_ = id;
     }
 
Index: code/branches/questsystem/src/orxonox/objects/AddQuestHint.h
===================================================================
--- code/branches/questsystem/src/orxonox/objects/AddQuestHint.h	(revision 2076)
+++ code/branches/questsystem/src/orxonox/objects/AddQuestHint.h	(revision 2081)
@@ -59,6 +59,5 @@
             inline const std::string & getHintId(void) const
                 { return this->hintId_; }
-	    inline void setHintId(const std::string & id)
-                { this->hintId_ = id; }
+	    void setHintId(const std::string & id);
     
     };
Index: code/branches/questsystem/src/orxonox/objects/ChangeQuestStatus.cc
===================================================================
--- code/branches/questsystem/src/orxonox/objects/ChangeQuestStatus.cc	(revision 2076)
+++ code/branches/questsystem/src/orxonox/objects/ChangeQuestStatus.cc	(revision 2081)
@@ -29,4 +29,5 @@
 #include "core/CoreIncludes.h"
 
+#include "QuestItem.h"
 #include "ChangeQuestStatus.h"
 
@@ -46,4 +47,14 @@
     }
     
+    void ChangeQuestStatus::setQuestId(const std::string & id)
+    {
+        if(!QuestItem::isId(id))
+        {
+            COUT(2) << "Invalid id. QuestItem id {" << id << "} could not be set." << std::endl;
+            return;
+        }
+        this->questId_ = id;
+    }
+    
     void ChangeQuestStatus::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
Index: code/branches/questsystem/src/orxonox/objects/ChangeQuestStatus.h
===================================================================
--- code/branches/questsystem/src/orxonox/objects/ChangeQuestStatus.h	(revision 2076)
+++ code/branches/questsystem/src/orxonox/objects/ChangeQuestStatus.h	(revision 2081)
@@ -62,6 +62,5 @@
             
 	private:
-            inline void setQuestId(const std::string & id)
-                { this->questId_ = id; }
+	    void setQuestId(const std::string & id);
 
     };
Index: code/branches/questsystem/src/orxonox/objects/GlobalQuest.cc
===================================================================
--- code/branches/questsystem/src/orxonox/objects/GlobalQuest.cc	(revision 2076)
+++ code/branches/questsystem/src/orxonox/objects/GlobalQuest.cc	(revision 2081)
@@ -58,5 +58,5 @@
         SUPER(GlobalQuest, XMLPort, xmlelement, mode);
 
-        COUT(1) << "New GlobalQuest {" << this->getId() << "} created." << std::endl;
+        COUT(3) << "New GlobalQuest {" << this->getId() << "} created." << std::endl;
     }
     
Index: code/branches/questsystem/src/orxonox/objects/LocalQuest.cc
===================================================================
--- code/branches/questsystem/src/orxonox/objects/LocalQuest.cc	(revision 2076)
+++ code/branches/questsystem/src/orxonox/objects/LocalQuest.cc	(revision 2081)
@@ -54,5 +54,5 @@
         SUPER(LocalQuest, XMLPort, xmlelement, mode);
 
-        COUT(1) << "New LocalQuest {" << this->getId() << "} created." << std::endl;
+        COUT(3) << "New LocalQuest {" << this->getId() << "} created." << std::endl;
     }
     
Index: code/branches/questsystem/src/orxonox/objects/Quest.cc
===================================================================
--- code/branches/questsystem/src/orxonox/objects/Quest.cc	(revision 2076)
+++ code/branches/questsystem/src/orxonox/objects/Quest.cc	(revision 2081)
@@ -88,4 +88,6 @@
         
         this->parentQuest_ = quest;
+        
+        COUT(3) << "Parent Quest {" << quest->getId() << "} was added to Quest {" << this->getId() << "}." << std::endl;
         return true;
     }
@@ -109,4 +111,6 @@
         quest->setParentQuest(this);
         this->subQuests_.push_back(quest);
+        
+        COUT(3) << "Sub Quest {" << quest->getId() << "} was added to Quest {" << this->getId() << "}." << std::endl;
         return true;
     }
@@ -131,4 +135,6 @@
 	this->hints_.push_back(hint);
 	hint->setQuest(this);
+	
+	COUT(3) << "QuestHint {" << hint->getId() << "} was added to Quest {" << this->getId() << "}." << std::endl;
 	return true;
     }
@@ -147,4 +153,6 @@
         
         this->failEffects_.push_back(effect);
+        
+        COUT(3) << "A FailEffect was added to Quest {" << this->getId() << "}." << std::endl;
         return true;
     }
@@ -163,4 +171,6 @@
         
         this->completeEffects_.push_back(effect);
+        
+        COUT(3) << "A CompleteEffect was added to Quest {" << this->getId() << "}." << std::endl;
         return true;
     }
Index: code/branches/questsystem/src/orxonox/objects/QuestDescription.cc
===================================================================
--- code/branches/questsystem/src/orxonox/objects/QuestDescription.cc	(revision 2076)
+++ code/branches/questsystem/src/orxonox/objects/QuestDescription.cc	(revision 2081)
@@ -52,5 +52,5 @@
         XMLPortParam(QuestDescription, "description", setDescription, getDescription, xmlelement, mode);
         
-        COUT(1) << "New QuestDescription with title '" << this->getTitle() << "' created." << std::endl;
+        COUT(3) << "New QuestDescription with title '" << this->getTitle() << "' created." << std::endl;
     }
     
Index: code/branches/questsystem/src/orxonox/objects/QuestHint.cc
===================================================================
--- code/branches/questsystem/src/orxonox/objects/QuestHint.cc	(revision 2076)
+++ code/branches/questsystem/src/orxonox/objects/QuestHint.cc	(revision 2081)
@@ -64,5 +64,5 @@
 	SUPER(QuestHint, XMLPort, xmlelement, mode);
 	
-	COUT(1) << "New QuestHint {" << this->getId() << "} created." << std::endl;
+	COUT(3) << "New QuestHint {" << this->getId() << "} created." << std::endl;
     }
 
Index: code/branches/questsystem/src/orxonox/objects/QuestItem.cc
===================================================================
--- code/branches/questsystem/src/orxonox/objects/QuestItem.cc	(revision 2076)
+++ code/branches/questsystem/src/orxonox/objects/QuestItem.cc	(revision 2081)
@@ -71,4 +71,14 @@
     }
     
+    void QuestItem::setId(const std::string & id)
+    {
+        if(!isId(id))
+        {
+            COUT(2) << "Invalid id. QuestItem id {" << id << "} could not be set." << std::endl;
+            return;
+        }
+        this->id_ = id;
+    }
+    
     //const QuestDescription* QuestItem::getDescription(unsigned int index) const //!< Returns the description of the QuestItem.
     //{
Index: code/branches/questsystem/src/orxonox/objects/QuestItem.h
===================================================================
--- code/branches/questsystem/src/orxonox/objects/QuestItem.h	(revision 2076)
+++ code/branches/questsystem/src/orxonox/objects/QuestItem.h	(revision 2081)
@@ -64,6 +64,5 @@
 	    
 	protected:
-            inline void setId(const std::string & id)
-                { id_ = id; }
+	    void setId(const std::string & id);
 	    inline void setDescription(QuestDescription* description)
                 { this->description_ = description; }