Index: code/branches/objecthierarchy/src/core/Factory.cc
===================================================================
--- code/branches/objecthierarchy/src/core/Factory.cc	(revision 2085)
+++ code/branches/objecthierarchy/src/core/Factory.cc	(revision 2086)
@@ -76,5 +76,5 @@
         getFactoryPointer()->identifierStringMap_[name] = identifier;
         getFactoryPointer()->identifierNetworkIDMap_[identifier->getNetworkID()] = identifier;
-std::cout << identifier->getName() << ": " << identifier->getNetworkID() << std::endl;
+//std::cout << identifier->getName() << ": " << identifier->getNetworkID() << std::endl;
     }
 
@@ -89,5 +89,5 @@
         getFactoryPointer()->identifierNetworkIDMap_.erase(oldID);
         getFactoryPointer()->identifierNetworkIDMap_[newID] = identifier;
-std::cout << identifier->getName() << ": " << oldID << " -> " << newID << std::endl;
+//std::cout << identifier->getName() << ": " << oldID << " -> " << newID << std::endl;
     }
 
Index: code/branches/objecthierarchy/src/core/Identifier.h
===================================================================
--- code/branches/objecthierarchy/src/core/Identifier.h	(revision 2085)
+++ code/branches/objecthierarchy/src/core/Identifier.h	(revision 2086)
@@ -67,4 +67,5 @@
 #include "Iterator.h"
 #include "Super.h"
+#include "Functor.h"
 #include "util/Debug.h"
 #include "util/String.h"
Index: code/branches/objecthierarchy/src/orxonox/LevelManager.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/LevelManager.cc	(revision 2085)
+++ code/branches/objecthierarchy/src/orxonox/LevelManager.cc	(revision 2086)
@@ -103,5 +103,5 @@
     void LevelManager::clientConnected(unsigned int clientID)
     {
-        COUT(0) << "client connected" << std::endl;
+        COUT(3) << "client connected" << std::endl;
 
         // create new HumanPlayer instance
@@ -119,5 +119,5 @@
     void LevelManager::clientDisconnected(unsigned int clientID)
     {
-        COUT(0) << "client disconnected" << std::endl;
+        COUT(3) << "client disconnected" << std::endl;
 
         // remove from clients-map
Index: code/branches/objecthierarchy/src/orxonox/objects/gametypes/Gametype.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/gametypes/Gametype.cc	(revision 2085)
+++ code/branches/objecthierarchy/src/orxonox/objects/gametypes/Gametype.cc	(revision 2086)
@@ -58,6 +58,4 @@
         this->startCountdown_ = 0;
         this->bStartCountdownRunning_ = false;
-
-        COUT(0) << "created Gametype" << std::endl;
     }
 
Index: code/branches/objecthierarchy/src/orxonox/objects/infos/Level.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/infos/Level.cc	(revision 2085)
+++ code/branches/objecthierarchy/src/orxonox/objects/infos/Level.cc	(revision 2086)
@@ -56,6 +56,4 @@
         if (this->xmlfilename_.length() >= Settings::getDataPath().length())
             this->xmlfilename_ = this->xmlfilename_.substr(Settings::getDataPath().length());
-
-        COUT(0) << "created Level" << std::endl;
     }
 
@@ -139,5 +137,5 @@
     void Level::playerEntered(PlayerInfo* player)
     {
-        COUT(0) << "player entered level" << std::endl;
+        COUT(3) << "player entered level" << std::endl;
         player->setGametype(this->getGametype());
     }
@@ -145,4 +143,5 @@
     void Level::playerLeft(PlayerInfo* player)
     {
+        COUT(3) << "player left level" << std::endl;
         player->setGametype(0);
     }
Index: code/branches/objecthierarchy/src/orxonox/objects/worldentities/ControllableEntity.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/worldentities/ControllableEntity.cc	(revision 2085)
+++ code/branches/objecthierarchy/src/orxonox/objects/worldentities/ControllableEntity.cc	(revision 2086)
@@ -197,5 +197,5 @@
     void ControllableEntity::startLocalControl()
     {
-        std::cout << this->getObjectID() << " ###### start local control" << std::endl;
+//        std::cout << this->getObjectID() << " ###### start local control" << std::endl;
         this->camera_ = new Camera(this);
         this->camera_->requestFocus();
@@ -216,5 +216,5 @@
     void ControllableEntity::stopLocalControl()
     {
-        std::cout << "###### stop local control" << std::endl;
+//        std::cout << "###### stop local control" << std::endl;
         this->camera_->detachFromParent();
         delete this->camera_;