Index: code/trunk/visual_studio/vc8/audio.vcproj
===================================================================
--- code/trunk/visual_studio/vc8/audio.vcproj	(revision 1909)
+++ code/trunk/visual_studio/vc8/audio.vcproj	(revision 2087)
Index: code/trunk/visual_studio/vc8/audio.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/audio.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/audio.vsprops	(revision 2087)
Index: code/trunk/visual_studio/vc8/base.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/base.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/base.vsprops	(revision 2087)
Index: code/trunk/visual_studio/vc8/ceguilua.vcproj
===================================================================
--- code/trunk/visual_studio/vc8/ceguilua.vcproj	(revision 1909)
+++ code/trunk/visual_studio/vc8/ceguilua.vcproj	(revision 2087)
Index: code/trunk/visual_studio/vc8/ceguilua.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/ceguilua.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/ceguilua.vsprops	(revision 2087)
Index: code/trunk/visual_studio/vc8/core.vcproj
===================================================================
--- code/trunk/visual_studio/vc8/core.vcproj	(revision 1909)
+++ code/trunk/visual_studio/vc8/core.vcproj	(revision 2087)
@@ -165,4 +165,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\Event.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\GameState.cc"
 				>
@@ -173,4 +177,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\LuaBind.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\OrxonoxClass.cc"
 				>
@@ -181,5 +189,9 @@
 			</File>
 			<File
-				RelativePath="..\..\src\core\Script.cc"
+				RelativePath="..\..\src\core\Template.cc"
+				>
+			</File>
+			<File
+				RelativePath="..\..\src\core\XMLNameListener.cc"
 				>
 			</File>
@@ -397,4 +409,12 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\Event.h"
+				>
+			</File>
+			<File
+				RelativePath="..\..\src\core\EventIncludes.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\GameState.h"
 				>
@@ -405,4 +425,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\LuaBind.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\OrxonoxClass.h"
 				>
@@ -413,15 +437,19 @@
 			</File>
 			<File
-				RelativePath="..\..\src\core\Script.h"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\core\Super.h"
 				>
 			</File>
 			<File
+				RelativePath="..\..\src\core\Template.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\XMLIncludes.h"
 				>
 			</File>
+			<File
+				RelativePath="..\..\src\core\XMLNameListener.h"
+				>
+			</File>
 			<Filter
 				Name="input"
@@ -596,8 +624,4 @@
 				</File>
 				<File
-					RelativePath="..\..\src\core\Level.h"
-					>
-				</File>
-				<File
 					RelativePath="..\..\src\core\Loader.h"
 					>
@@ -609,4 +633,8 @@
 				<File
 					RelativePath="..\..\src\core\NamespaceNode.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\XMLFile.h"
 					>
 				</File>
Index: code/trunk/visual_studio/vc8/core.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/core.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/core.vsprops	(revision 2087)
Index: code/trunk/visual_studio/vc8/cpptcl.vcproj
===================================================================
--- code/trunk/visual_studio/vc8/cpptcl.vcproj	(revision 1909)
+++ code/trunk/visual_studio/vc8/cpptcl.vcproj	(revision 2087)
Index: code/trunk/visual_studio/vc8/cpptcl.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/cpptcl.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/cpptcl.vsprops	(revision 2087)
Index: code/trunk/visual_studio/vc8/debug.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/debug.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/debug.vsprops	(revision 2087)
Index: code/trunk/visual_studio/vc8/directories.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/directories.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/directories.vsprops	(revision 2087)
Index: code/trunk/visual_studio/vc8/lua.vcproj
===================================================================
--- code/trunk/visual_studio/vc8/lua.vcproj	(revision 1909)
+++ code/trunk/visual_studio/vc8/lua.vcproj	(revision 2087)
Index: code/trunk/visual_studio/vc8/lua.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/lua.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/lua.vsprops	(revision 2087)
Index: code/trunk/visual_studio/vc8/lua_static.vcproj
===================================================================
--- code/trunk/visual_studio/vc8/lua_static.vcproj	(revision 1909)
+++ code/trunk/visual_studio/vc8/lua_static.vcproj	(revision 2087)
Index: code/trunk/visual_studio/vc8/lua_static.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/lua_static.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/lua_static.vsprops	(revision 2087)
Index: code/trunk/visual_studio/vc8/network.vcproj
===================================================================
--- code/trunk/visual_studio/vc8/network.vcproj	(revision 1909)
+++ code/trunk/visual_studio/vc8/network.vcproj	(revision 2087)
@@ -18,5 +18,5 @@
 		<Configuration
 			Name="Debug|Win32"
-			ConfigurationType="4"
+			ConfigurationType="2"
 			InheritedPropertySheets=".\debug.vsprops;.\network.vsprops"
 			CharacterSet="1"
@@ -50,5 +50,5 @@
 			/>
 			<Tool
-				Name="VCLibrarianTool"
+				Name="VCLinkerTool"
 			/>
 			<Tool
@@ -56,4 +56,7 @@
 			/>
 			<Tool
+				Name="VCManifestTool"
+			/>
+			<Tool
 				Name="VCXDCMakeTool"
 			/>
@@ -63,4 +66,10 @@
 			<Tool
 				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCAppVerifierTool"
+			/>
+			<Tool
+				Name="VCWebDeploymentTool"
 			/>
 			<Tool
@@ -70,5 +79,5 @@
 		<Configuration
 			Name="Release|Win32"
-			ConfigurationType="4"
+			ConfigurationType="2"
 			InheritedPropertySheets=".\release.vsprops;.\network.vsprops"
 			CharacterSet="1"
@@ -103,5 +112,5 @@
 			/>
 			<Tool
-				Name="VCLibrarianTool"
+				Name="VCLinkerTool"
 			/>
 			<Tool
@@ -109,4 +118,7 @@
 			/>
 			<Tool
+				Name="VCManifestTool"
+			/>
+			<Tool
 				Name="VCXDCMakeTool"
 			/>
@@ -116,4 +128,10 @@
 			<Tool
 				Name="VCFxCopTool"
+			/>
+			<Tool
+				Name="VCAppVerifierTool"
+			/>
+			<Tool
+				Name="VCWebDeploymentTool"
 			/>
 			<Tool
@@ -131,4 +149,8 @@
 			>
 			<File
+				RelativePath="..\..\src\network\ChatListener.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\network\Client.cc"
 				>
@@ -136,4 +158,8 @@
 			<File
 				RelativePath="..\..\src\network\ClientConnection.cc"
+				>
+			</File>
+			<File
+				RelativePath="..\..\src\network\ClientConnectionListener.cc"
 				>
 			</File>
@@ -213,4 +239,8 @@
 			>
 			<File
+				RelativePath="..\..\src\network\ChatListener.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\network\Client.h"
 				>
@@ -218,4 +248,8 @@
 			<File
 				RelativePath="..\..\src\network\ClientConnection.h"
+				>
+			</File>
+			<File
+				RelativePath="..\..\src\network\ClientConnectionListener.h"
 				>
 			</File>
Index: code/trunk/visual_studio/vc8/network.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/network.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/network.vsprops	(revision 2087)
@@ -9,5 +9,5 @@
 		Name="VCCLCompilerTool"
 		AdditionalOptions="/MP2"
-		PreprocessorDefinitions="ORXONOX_NO_EXPORTS;NETWORK_STATIC_BUILD"
+		PreprocessorDefinitions="NETWORK_SHARED_BUILD"
 	/>
 	<Tool
Index: code/trunk/visual_studio/vc8/ois.vcproj
===================================================================
--- code/trunk/visual_studio/vc8/ois.vcproj	(revision 1909)
+++ code/trunk/visual_studio/vc8/ois.vcproj	(revision 2087)
Index: code/trunk/visual_studio/vc8/ois.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/ois.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/ois.vsprops	(revision 2087)
Index: code/trunk/visual_studio/vc8/orxonox.vcproj
===================================================================
--- code/trunk/visual_studio/vc8/orxonox.vcproj	(revision 1909)
+++ code/trunk/visual_studio/vc8/orxonox.vcproj	(revision 2087)
@@ -39,5 +39,4 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				AdditionalOptions="/Zm200"
 			/>
 			<Tool
@@ -103,5 +102,4 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				AdditionalOptions="/Zm200"
 			/>
 			<Tool
@@ -153,5 +151,13 @@
 			>
 			<File
+				RelativePath="..\..\src\orxonox\CameraManager.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\orxonox\GraphicsEngine.cc"
+				>
+			</File>
+			<File
+				RelativePath="..\..\src\orxonox\LevelManager.cc"
 				>
 			</File>
@@ -184,49 +190,17 @@
 				>
 			</File>
-			<File
-				RelativePath="..\..\src\orxonox\SignalHandler.cc"
-				>
-			</File>
 			<Filter
 				Name="objects"
 				>
 				<File
-					RelativePath="..\..\src\orxonox\objects\Ambient.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\Backlight.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\BillboardProjectile.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\Camera.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\CameraHandler.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\Model.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\NPC.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\ParticleProjectile.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\ParticleSpawner.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\Projectile.cc"
+					RelativePath="..\..\src\orxonox\objects\EventDispatcher.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\orxonox\objects\EventListener.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\orxonox\objects\EventTarget.cc"
 					>
 				</File>
@@ -234,44 +208,8 @@
 					RelativePath="..\..\src\orxonox\objects\Radar.cc"
 					>
-					<FileConfiguration
-						Name="Debug|Win32"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							ObjectFile="$(IntDir)\$(InputName)1.obj"
-							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release|Win32"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							ObjectFile="$(IntDir)\$(InputName)1.obj"
-							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
-						/>
-					</FileConfiguration>
 				</File>
 				<File
 					RelativePath="..\..\src\orxonox\objects\RadarListener.cc"
 					>
-					<FileConfiguration
-						Name="Debug|Win32"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							ObjectFile="$(IntDir)\$(InputName)1.obj"
-							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release|Win32"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							ObjectFile="$(IntDir)\$(InputName)1.obj"
-							XMLDocumentationFileName="$(IntDir)\$(InputName)1.xdc"
-						/>
-					</FileConfiguration>
 				</File>
 				<File
@@ -280,17 +218,13 @@
 				</File>
 				<File
-					RelativePath="..\..\src\orxonox\objects\RotatingProjectile.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\Skybox.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\SpaceShip.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\SpaceShipAI.cc"
+					RelativePath="..\..\src\orxonox\objects\Scene.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\orxonox\objects\Script.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\orxonox\objects\Test.cc"
 					>
 				</File>
@@ -299,8 +233,152 @@
 					>
 				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\WorldEntity.cc"
-					>
-				</File>
+				<Filter
+					Name="worldentities"
+					>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\Backlight.cc"
+						>
+						<FileConfiguration
+							Name="Debug|Win32"
+							ExcludedFromBuild="true"
+							>
+							<Tool
+								Name="VCCLCompilerTool"
+							/>
+						</FileConfiguration>
+						<FileConfiguration
+							Name="Release|Win32"
+							ExcludedFromBuild="true"
+							>
+							<Tool
+								Name="VCCLCompilerTool"
+							/>
+						</FileConfiguration>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\Billboard.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\BlinkingBillboard.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\Camera.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\CameraPosition.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\ControllableEntity.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\Light.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\Model.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\MovableEntity.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\ParticleEmitter.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\ParticleSpawner.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\PositionableEntity.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\SpawnPoint.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\WorldEntity.cc"
+						>
+					</File>
+					<Filter
+						Name="pawns"
+						>
+						<File
+							RelativePath="..\..\src\orxonox\objects\worldentities\pawns\Pawn.cc"
+							>
+						</File>
+						<File
+							RelativePath="..\..\src\orxonox\objects\worldentities\pawns\SpaceShip.cc"
+							>
+						</File>
+						<File
+							RelativePath="..\..\src\orxonox\objects\worldentities\pawns\Spectator.cc"
+							>
+						</File>
+					</Filter>
+					<Filter
+						Name="triggers"
+						>
+						<File
+							RelativePath="..\..\src\orxonox\objects\worldentities\triggers\DistanceTrigger.cc"
+							>
+						</File>
+						<File
+							RelativePath="..\..\src\orxonox\objects\worldentities\triggers\EventTrigger.cc"
+							>
+						</File>
+						<File
+							RelativePath="..\..\src\orxonox\objects\worldentities\triggers\Trigger.cc"
+							>
+						</File>
+					</Filter>
+				</Filter>
+				<Filter
+					Name="gametypes"
+					>
+					<File
+						RelativePath="..\..\src\orxonox\objects\gametypes\Gametype.cc"
+						>
+					</File>
+				</Filter>
+				<Filter
+					Name="infos"
+					>
+					<File
+						RelativePath="..\..\src\orxonox\objects\infos\HumanPlayer.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\infos\Info.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\infos\Level.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\infos\PlayerInfo.cc"
+						>
+					</File>
+				</Filter>
+				<Filter
+					Name="controllers"
+					>
+					<File
+						RelativePath="..\..\src\orxonox\objects\controllers\Controller.cc"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\controllers\HumanController.cc"
+						>
+					</File>
+				</Filter>
 			</Filter>
 			<Filter
@@ -309,8 +387,4 @@
 				<File
 					RelativePath="..\..\src\orxonox\tools\BillboardSet.cc"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\tools\Light.cc"
 					>
 				</File>
@@ -413,4 +487,8 @@
 					>
 					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\ChatOverlay.cc"
+						>
+					</File>
+					<File
 						RelativePath="..\..\src\orxonox\overlays\hud\HUDBar.cc"
 						>
@@ -452,60 +530,12 @@
 					RelativePath="..\..\src\orxonox\gui\OgreCEGUIRenderer.cpp"
 					>
-					<FileConfiguration
-						Name="Debug|Win32"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release|Win32"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
 				</File>
 				<File
 					RelativePath="..\..\src\orxonox\gui\OgreCEGUIResourceProvider.cpp"
 					>
-					<FileConfiguration
-						Name="Debug|Win32"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release|Win32"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
 				</File>
 				<File
 					RelativePath="..\..\src\orxonox\gui\OgreCEGUITexture.cpp"
 					>
-					<FileConfiguration
-						Name="Debug|Win32"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release|Win32"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
 				</File>
 			</Filter>
@@ -557,8 +587,16 @@
 			>
 			<File
+				RelativePath="..\..\src\orxonox\CameraManager.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\orxonox\GraphicsEngine.h"
 				>
 			</File>
 			<File
+				RelativePath="..\..\src\orxonox\LevelManager.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\orxonox\OrxonoxPrereqs.h"
 				>
@@ -572,49 +610,17 @@
 				>
 			</File>
-			<File
-				RelativePath="..\..\src\orxonox\SignalHandler.h"
-				>
-			</File>
 			<Filter
 				Name="objects"
 				>
 				<File
-					RelativePath="..\..\src\orxonox\objects\Ambient.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\Backlight.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\BillboardProjectile.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\Camera.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\CameraHandler.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\Model.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\NPC.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\ParticleProjectile.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\ParticleSpawner.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\Projectile.h"
+					RelativePath="..\..\src\orxonox\objects\EventDispatcher.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\orxonox\objects\EventListener.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\orxonox\objects\EventTarget.h"
 					>
 				</File>
@@ -632,17 +638,13 @@
 				</File>
 				<File
-					RelativePath="..\..\src\orxonox\objects\RotatingProjectile.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\Skybox.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\SpaceShip.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\SpaceShipAI.h"
+					RelativePath="..\..\src\orxonox\objects\Scene.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\orxonox\objects\Script.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\orxonox\objects\Test.h"
 					>
 				</File>
@@ -651,8 +653,132 @@
 					>
 				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\WorldEntity.h"
-					>
-				</File>
+				<Filter
+					Name="worldentities"
+					>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\Backlight.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\Billboard.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\BlinkingBillboard.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\Camera.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\CameraPosition.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\ControllableEntity.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\Light.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\Model.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\MovableEntity.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\ParticleEmitter.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\ParticleSpawner.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\PositionableEntity.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\SpawnPoint.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\worldentities\WorldEntity.h"
+						>
+					</File>
+					<Filter
+						Name="pawns"
+						>
+						<File
+							RelativePath="..\..\src\orxonox\objects\worldentities\pawns\Pawn.h"
+							>
+						</File>
+						<File
+							RelativePath="..\..\src\orxonox\objects\worldentities\pawns\SpaceShip.h"
+							>
+						</File>
+						<File
+							RelativePath="..\..\src\orxonox\objects\worldentities\pawns\Spectator.h"
+							>
+						</File>
+					</Filter>
+					<Filter
+						Name="triggers"
+						>
+						<File
+							RelativePath="..\..\src\orxonox\objects\worldentities\triggers\DistanceTrigger.h"
+							>
+						</File>
+						<File
+							RelativePath="..\..\src\orxonox\objects\worldentities\triggers\EventTrigger.h"
+							>
+						</File>
+						<File
+							RelativePath="..\..\src\orxonox\objects\worldentities\triggers\Trigger.h"
+							>
+						</File>
+					</Filter>
+				</Filter>
+				<Filter
+					Name="gametypes"
+					>
+					<File
+						RelativePath="..\..\src\orxonox\objects\gametypes\Gametype.h"
+						>
+					</File>
+				</Filter>
+				<Filter
+					Name="infos"
+					>
+					<File
+						RelativePath="..\..\src\orxonox\objects\infos\Info.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\infos\Level.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\infos\PlayerInfo.h"
+						>
+					</File>
+				</Filter>
+				<Filter
+					Name="controllers"
+					>
+					<File
+						RelativePath="..\..\src\orxonox\objects\controllers\Controller.h"
+						>
+					</File>
+					<File
+						RelativePath="..\..\src\orxonox\objects\controllers\HumanController.h"
+						>
+					</File>
+				</Filter>
 			</Filter>
 			<Filter
@@ -664,8 +790,4 @@
 				</File>
 				<File
-					RelativePath="..\..\src\orxonox\tools\Light.h"
-					>
-				</File>
-				<File
 					RelativePath="..\..\src\orxonox\tools\Mesh.h"
 					>
@@ -714,4 +836,8 @@
 					Name="hud"
 					>
+					<File
+						RelativePath="..\..\src\orxonox\overlays\hud\ChatOverlay.h"
+						>
+					</File>
 					<File
 						RelativePath="..\..\src\orxonox\overlays\hud\HUDBar.h"
Index: code/trunk/visual_studio/vc8/orxonox.vcproj.user
===================================================================
--- code/trunk/visual_studio/vc8/orxonox.vcproj.user	(revision 1909)
+++ code/trunk/visual_studio/vc8/orxonox.vcproj.user	(revision 2087)
Index: code/trunk/visual_studio/vc8/orxonox.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/orxonox.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/orxonox.vsprops	(revision 2087)
@@ -8,6 +8,6 @@
 	<Tool
 		Name="VCCLCompilerTool"
-		AdditionalOptions="/MP2"
-		PreprocessorDefinitions="ORXONOX_NO_EXPORTS;NETWORK_STATIC_BUILD;LUA_BUILD_AS_DLL"
+		AdditionalOptions="/MP2 /Zm200"
+		PreprocessorDefinitions="ORXONOX_NO_EXPORTS;ORXONOX_ENABLE_PCH;LUA_BUILD_AS_DLL"
 		UsePrecompiledHeader="2"
 		PrecompiledHeaderThrough="OrxonoxStableHeaders.h"
@@ -22,5 +22,5 @@
 		Name="VCPostBuildEventTool"
 		Description="Copying files from init folder..."
-		CommandLine="for %%a in ($(RootDir)\init\$(SolutionName)\$(ConfigurationName)\*) do replace %%a $(OutDir). /A &gt;nul&#x0D;&#x0A;for %%a in ($(RootDir)\init\common\*) do replace %%a $(OutDir). /A &gt;nul"
+		CommandLine="for %%a in ($(RootDir)\init\$(SolutionName)\$(ConfigurationName)\*) do replace %%a $(OutDir). /A &gt;nul&#x0D;&#x0A;for %%a in ($(RootDir)\init\common\*) do replace %%a $(OutDir). /A &gt;nul&#x0D;&#x0A;"
 	/>
 </VisualStudioPropertySheet>
Index: code/trunk/visual_studio/vc8/orxonox_vc8.sln
===================================================================
--- code/trunk/visual_studio/vc8/orxonox_vc8.sln	(revision 1909)
+++ code/trunk/visual_studio/vc8/orxonox_vc8.sln	(revision 2087)
Index: code/trunk/visual_studio/vc8/release.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/release.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/release.vsprops	(revision 2087)
Index: code/trunk/visual_studio/vc8/tinyxml.vcproj
===================================================================
--- code/trunk/visual_studio/vc8/tinyxml.vcproj	(revision 1909)
+++ code/trunk/visual_studio/vc8/tinyxml.vcproj	(revision 2087)
Index: code/trunk/visual_studio/vc8/tinyxml.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/tinyxml.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/tinyxml.vsprops	(revision 2087)
Index: code/trunk/visual_studio/vc8/tolua.vcproj
===================================================================
--- code/trunk/visual_studio/vc8/tolua.vcproj	(revision 1909)
+++ code/trunk/visual_studio/vc8/tolua.vcproj	(revision 2087)
Index: code/trunk/visual_studio/vc8/tolua.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/tolua.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/tolua.vsprops	(revision 2087)
Index: code/trunk/visual_studio/vc8/tolua_static.vcproj
===================================================================
--- code/trunk/visual_studio/vc8/tolua_static.vcproj	(revision 1909)
+++ code/trunk/visual_studio/vc8/tolua_static.vcproj	(revision 2087)
Index: code/trunk/visual_studio/vc8/tolua_static.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/tolua_static.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/tolua_static.vsprops	(revision 2087)
Index: code/trunk/visual_studio/vc8/toluagen.vcproj
===================================================================
--- code/trunk/visual_studio/vc8/toluagen.vcproj	(revision 1909)
+++ code/trunk/visual_studio/vc8/toluagen.vcproj	(revision 2087)
Index: code/trunk/visual_studio/vc8/toluagen.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/toluagen.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/toluagen.vsprops	(revision 2087)
Index: code/trunk/visual_studio/vc8/toluagen_orxonox.vcproj
===================================================================
--- code/trunk/visual_studio/vc8/toluagen_orxonox.vcproj	(revision 1909)
+++ code/trunk/visual_studio/vc8/toluagen_orxonox.vcproj	(revision 2087)
Index: code/trunk/visual_studio/vc8/toluagen_orxonox.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/toluagen_orxonox.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/toluagen_orxonox.vsprops	(revision 2087)
Index: code/trunk/visual_studio/vc8/util.vcproj
===================================================================
--- code/trunk/visual_studio/vc8/util.vcproj	(revision 1909)
+++ code/trunk/visual_studio/vc8/util.vcproj	(revision 2087)
@@ -181,4 +181,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\util\SignalHandler.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\util\String.cc"
 				>
@@ -227,4 +231,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\util\MathConvert.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\util\MultiType.h"
 				>
@@ -244,4 +252,8 @@
 			<File
 				RelativePath="..\..\src\util\OutputHandler.h"
+				>
+			</File>
+			<File
+				RelativePath="..\..\src\util\SignalHandler.h"
 				>
 			</File>
Index: code/trunk/visual_studio/vc8/util.vsprops
===================================================================
--- code/trunk/visual_studio/vc8/util.vsprops	(revision 1909)
+++ code/trunk/visual_studio/vc8/util.vsprops	(revision 2087)