Index: code/trunk/src/orxonox/objects/quest/Quest.cc
===================================================================
--- code/trunk/src/orxonox/objects/quest/Quest.cc	(revision 2091)
+++ code/trunk/src/orxonox/objects/quest/Quest.cc	(revision 2092)
@@ -34,9 +34,11 @@
 namespace orxonox {
 
-    Quest::Quest() : QuestItem()
-    {
+    Quest::Quest(BaseObject* creator) : QuestItem(creator)
+    {
+        RegisterObject(Quest);
+
         this->initialize();
     }
-    
+
     /**
     @brief
@@ -45,19 +47,19 @@
     Quest::~Quest()
     {
-        
-    }
-    
+
+    }
+
     void Quest::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
         SUPER(Quest, XMLPort, xmlelement, mode);
-        
+
         XMLPortObject(Quest, Quest, "", addSubQuest, getSubQuests, xmlelement, mode);
         XMLPortObject(Quest, QuestHint, "", addHint, getHints, xmlelement, mode);
         XMLPortObject(Quest, QuestEffect, "fail-effects", addFailEffect, getFailEffects, xmlelement, mode);
         XMLPortObject(Quest, QuestEffect, "complete-effects", addCompleteEffect, getCompleteEffects, xmlelement, mode);
-        
+
         QuestManager::registerQuest(this); //Registers the quest with the QuestManager.
     }
-    
+
     /**
     @brief
@@ -67,5 +69,5 @@
     {
         RegisterObject(Quest);
-        
+
         this->parentQuest_ = NULL;
     }
@@ -86,11 +88,11 @@
             return false;
         }
-        
+
         this->parentQuest_ = quest;
-        
+
         COUT(3) << "Parent Quest {" << quest->getId() << "} was added to Quest {" << this->getId() << "}." << std::endl;
         return true;
     }
-    
+
     /**
     @brief
@@ -108,16 +110,16 @@
             return false;
         }
-        
+
         quest->setParentQuest(this);
         this->subQuests_.push_back(quest);
-        
+
         COUT(3) << "Sub Quest {" << quest->getId() << "} was added to Quest {" << this->getId() << "}." << std::endl;
         return true;
     }
-    
-    
-    /**
-    @brief
-        Adds a Hint to the list of hints 
+
+
+    /**
+    @brief
+        Adds a Hint to the list of hints
     @param hint
         The hint that should be added to the list of hints.
@@ -132,15 +134,15 @@
             return false;
         }
-        
+
 	this->hints_.push_back(hint);
 	hint->setQuest(this);
-	
+
 	COUT(3) << "QuestHint {" << hint->getId() << "} was added to Quest {" << this->getId() << "}." << std::endl;
 	return true;
     }
-    
-    /**
-    @brief
-        
+
+    /**
+    @brief
+
     */
     bool Quest::addFailEffect(QuestEffect* effect)
@@ -151,14 +153,14 @@
             return false;
         }
-        
+
         this->failEffects_.push_back(effect);
-        
+
         COUT(3) << "A FailEffect was added to Quest {" << this->getId() << "}." << std::endl;
         return true;
     }
-    
-    /**
-    @brief
-        
+
+    /**
+    @brief
+
     */
     bool Quest::addCompleteEffect(QuestEffect* effect)
@@ -169,14 +171,14 @@
             return false;
         }
-        
+
         this->completeEffects_.push_back(effect);
-        
+
         COUT(3) << "A CompleteEffect was added to Quest {" << this->getId() << "}." << std::endl;
         return true;
     }
-    
-    /**
-    @brief
-        
+
+    /**
+    @brief
+
     */
     const Quest* Quest::getParentQuest(void)
@@ -184,8 +186,8 @@
         return this->parentQuest_;
     }
-    
-    /**
-    @brief
-        
+
+    /**
+    @brief
+
     */
     const Quest* Quest::getSubQuests(unsigned int index) const
@@ -202,8 +204,8 @@
         return NULL;
     }
-    
-    /**
-    @brief
-        
+
+    /**
+    @brief
+
     */
     const QuestHint* Quest::getHints(unsigned int index) const
@@ -220,8 +222,8 @@
         return NULL;
     }
-    
-    /**
-    @brief
-        
+
+    /**
+    @brief
+
     */
     const QuestEffect* Quest::getFailEffects(unsigned int index) const
@@ -238,8 +240,8 @@
         return NULL;
     }
-    
-    /**
-    @brief
-        
+
+    /**
+    @brief
+
     */
     const QuestEffect* Quest::getCompleteEffects(unsigned int index) const
@@ -256,5 +258,5 @@
         return NULL;
     }
-    
+
     /**
     @brief
@@ -271,5 +273,5 @@
         return this->getStatus(player) == questStatus::inactive;
     }
-    
+
     /**
     @brief
@@ -287,5 +289,5 @@
         return this->getStatus(player) == questStatus::active;
     }
-    
+
     /**
     @brief
@@ -302,5 +304,5 @@
         return this->getStatus(player) == questStatus::failed;
     }
-    
+
     /**
     @brief
@@ -317,5 +319,5 @@
         return this->getStatus(player) == questStatus::completed;
     }
-    
+
     /**
     @brief
@@ -336,5 +338,5 @@
         return false;
     }
-    
+
     /**
     @brief
@@ -356,5 +358,5 @@
         return false;
     }
-    
+
     /**
     @brief